//LN^LCDRg[HD44780	Cu
//wt]xH쎺	http://jsdiy.web.fc2.com

#ifndef HD44780_LCDLIB_H_
#define HD44780_LCDLIB_H_

void	lcdInit(uint8_t x_columnSize, uint8_t y_rowSize);
void	lcdSetLineMode(uint8_t lineMode, uint8_t cursorFlag);
void	lcdSetPosXY(uint8_t x_column, uint8_t y_row);
void	lcdCmd(uint8_t data);
void	lcdData(uint8_t data);
void	lcdPutChar(char c);
void	lcdPutInt(int16_t n);
void	lcdPutUInt(uint16_t n);
void	lcdPutByte(uint8_t n);

//I2C-CharLCDŃ}X^[ɒ`邽߁i֐͌Ȃ悤Ɂjʃt@CɂB
#if (0)

//s̓ݒ肷g߁ilcdSetLineMode()̈j
#define	LCD_LINEMODE_SEPARATE	0b00	//1sڂ2sڂ͓ƗĂ
#define	LCD_LINEMODE_COMBINE	0b01	//1sڍs2sڍs֎IɑBŜƂ1sڍs\̈̐擪A2sڍs
//
#define	LCD_LINEMODE_STOP		0b00	//Œ~Bz鏑݂͖
#define	LCD_LINEMODE_OVERWRITE	0b10	//擪֖߂A㏑ŏݑsBJ[\\iʂ̂ǂ܂ŕ\i񂾂悤Ɂj
//
#define	LCD_CURSOR_ON	1	//J[\\B㏑[h̏ꍇɖ𗧂
#define	LCD_CURSOR_OFF	0	//J[\\ȂB

//HD44780 Instruction
#define	LCD_CMD_CLEAR_DISPLAY	0b00000001
#define	LCD_CMD_RETURN_HOME		0b00000010
#define	LCD_CMD_ENTRY_MODE		0b00000100
#define	LCD_CMD_DISPLAY_MODE	0b00001000
#define	LCD_CMD_CURSOR_MODE		0b00010000
#define	LCD_CMD_FUNCTION_SET	0b00100000
#define	LCD_CMD_SET_CGRAM_ADRS	0b01000000
#define	LCD_CMD_SET_DDRAM_ADRS	0b10000000

//HD44780 Instructioñp[^
//(LCD_CMD_AAA | LCD_SUBCMD_XXX1 | LCD_SUBCMD_XXX2 | c)̌`Ŏg

//LCD_CMD_ENTRY_MODE
#define	LCD_SUBCMD_INCREMENT	0b00000010	//͈ʒui߂iw肾Decrementj
#define	LCD_SUBCMD_WITH_SHIFT	0b00000001	//\Vtg𔺂iLCD_CMD_CURSOR_MODEݒ肷j

//LCD_CMD_DISPLAY_MODE
#define	LCD_SUBCMD_SET_DISPLAY	0b00000100	//ʕ\iw肾ƕ\eۂ܂܉ʂj
#define	LCD_SUBCMD_SET_CURSOR	0b00000010	//J[\\iA_[o[\j
#define	LCD_SUBCMD_CURSOR_BLINK	0b00000001	//J[\_łiɔ킳č}X_łj

//LCD_CMD_CURSOR_MODE
#define	LCD_SUBCMD_SHIFT_ON		0b00001000	//DDRAM̕ύXɕ\Vtgiw肾ƃJ[\ړj
#define	LCD_SUBCMD_RIGHT		0b00000100	//EփVtgiw肾ƍցjLAJ[\ړ[h͈ӖȂ

//LCD_CMD_FUNCTION_SET
#define	LCD_SUBCMD_DL8BIT		0b00010000	//Data Length 8-bitiw肾4-bit[hj
#define	LCD_SUBCMD_2LINE		0b00001000	//\2sgpiw肾1ŝݎgp\ɂȂj
#define	LCD_SUBCMD_FONT5X10		0b00000100	//Font Type 5x10iw肾5x8jSC1602/SD1602͕IɔΉ

#endif	//if(0)
#include "HD44780_Instruction.h"

#endif	//HD44780_LCDLIB_H_
